
{ MausNet-Definitionen }

{ js, 30.03.89 }
{ kh, 08.05.94 }

unit mnDef;

interface

uses
  Dos, m7Config, m7FileIO, m7Dec, m7UtilLo, m7time {$ifdef OS2} ,USE32 {$endif};

const
  DefBoxenMax     = 255;
  DefDirectBoxMax = 12;
  DefGateMax      = 500;
  DefGrpMax       = GruppenMax;
  NoGrp           = DefGrpMax; { dh. Gruppe wird nicht verwendet }
  SysopsNetGrp    = 1;
  NetzMitt        = - 2; { Sendernummer fr MausNet-Mitteilung }

const
  MausNetDatFile  = 'NET-ALL.DAT';
  MausNetTstFile  = 'NET-TST.DAT';
  NetGrpFile      = 'NET-GRP.DAT';
  BoxGrpFile      = 'BOX-GRP.DAT';
  GrpStatFile     = 'MN-GRU.DAT';
  MsgStatFile     = 'MN-MSG.DAT';
  TimingFile      = 'MN-TIM.DAT';
  AliasFile       = 'MN-ALIAS.DAT';
const
  MaxNummern      = 2; { max. Anzahl Telefonnummern pro Box }
type
  { Gruppe          = 0 .. DefGrpMax; }
  NetzGruppe      = tGruppe;
  Box             = 0 .. DefBoxenMax;
  Box1            = 1 .. DefBoxenMax;
  DirectBox       = 0 .. DefDirectBoxMax;
  Gateway0        = 0 .. DefGateMax;
  Gateway1        = 1 .. DefGateMax;
  ImNetzTyp       = (NichtImNetz, ImNetz);
  NetGrpInfoRec   =
    record
      ToBox           : array [DirectBox] of ImNetzTyp;
      { "Box bekommt Gruppe direkt von uns";
   in ToBox[DirectBox[ThisBox]] stehen die Gruppen, die "wir hier" bekommen }
      ToGrp           : tGruppe;
      { NetzGruppe -> lokale Gruppe; NoGrp: keine lokale Gruppe vorhanden }
      ExMsgBack       : System.Integer;
      { soviele Mitteilungen gehen bers Netz, wenn die Verbindung
      "NeuImNetz" ist }
      { 16 Bytes }
      dummy           : array [17 .. 32] of Byte;
    end;
  NetGrpInfoTyp   = array [NetzGruppe] of ^ NetGrpInfoRec;
  GrpInfoRec      =
    record
      unused1         : string[10];
      crc             : System.Word;
      LastEdit        : System.Integer;
      UserInfo,
      SysOpInfo       : string[65];
      BoxListe        : set of Box;
      Secret          : Boolean;
      LastEditTime    : System.Integer;
      Name            : GruppenStr;
      OriginNet       : byte; { eigentlich: tOriginNet }
      GrpLanguage     : byte; { eigentlich; tGrpLanguage }
      { 225 Bytes }
      dummy           : array [226 .. 256] of Byte;
    end;
  pGrpInfoRec     = ^ GrpInfoRec;
  GrpInfoTyp      = array [NetzGruppe] of pGrpInfoRec;
const
  cConnectTags    = 'ADVZPH';
type
  tConnectTypes   = (cAnalogV32bis, cIsdnX75, cAnalogV34,
                     cAnalogZyX, cAnalogPEP, cAnalogHST);
  tConnectSet     = set of tConnectTypes;
  DomainStr       = string[50];
  tNetAlias       =
    record
      boxnr           : Box;
      domain          : DomainStr;
    end;
  BoxInfoRecTyp   =
    record
      Name            : string[30];
      Kuerzel         : tKuerzel;
      Nummer1         : string[20];
      ConnTyp         : array[1..2] of tConnectSet;
                        { extra nicht MaxNummern, wg. Verschiebung im Record }
      UeberMir        : Boolean;
      UnterMir        : Boolean; { DIREKT unter mir, oder FremdBox }
      Ebene           : Byte;
      ViaBox          : Box; { auf welchem Weg? }
      Direct          : DirectBox;
        { Boxen^[ThisBox].DirectBox sollte immer 0 sein }
      FremdBox        : Boolean;
        { Benutzer -100-Boxnummer (?) in der lokalen Box }
      Nummer2         : string[20];
      NrGeheim        : array [1..2] of boolean;
      { 92 Bytes }
      dummy           : array [93 .. 96] of Byte;
    end;
  BoxenArray      = array [Box1] of BoxInfoRecTyp;
  BoxenKuerzel    = array [Box1] of tKuerzel;
  GrpToNetGrpTyp  = array [tGruppe] of NetzGruppe;
  GateWayTyp      = array [Gateway1] of
    record
      GateName        : string[20];
      GateDist        : System.Integer;      { Box oder lokale Benutzernummer }
      { 23 Bytes }
      dummy           : array [24 .. 32] of Byte;
    end;
  DirectToBoxTyp  = array [DirectBox] of Box;
  MiscInfoTyp     =
    record
      MaxBoxen        : Box; { hchste MAUS-Nummer }
      ThisBox         : Box; { wer bin ich ? }
      MaxDirectBox    : DirectBox;
      { Anzahl direkt angeschlossener Boxen }
      { 3 Bytes }
      dummy           : array [4 .. 16] of Byte;
    end;
  BoxGruppenArray = array [Box1] of tGruppenSet;
  { Msg-Aufkommen-Statistik in <MsgStatFile> }
  MsgStatRec      =
    record
      Anzahl          : Longint;
      Bytes           : Longint;
    end;
  MsgStatTyp      =
    record
      Datum           : System.Integer;
      BoxMax          : Byte;
      Boxen           : array [DirectBox] of string[3]; { frher tKuerzel }
      Msgs            : array [Boolean, DirectBox, DirectBox] of MsgStatRec;
      { false = Allgemein, true = Pers.; 0 = ThisBox }
    end;
  GrpStatTyp      =
    record
      Datum           : System.Integer;
      Grps            : array [tGruppe] of
        record
          Anzahl          : System.Word;
          Bytes           : Longint;
        end;
    end;
  tListe          = (AEx, EEx, EVU, EPa, ENO, AVO, EVO, EPx, ANU, ENU);
  TimingTyp       =
    record
      IchBin,
      UeberMir        : Box;
      Datum           : System.Integer;
      Version         : string[2];
      T               : array [tListe] of SecondInt;
      Recs            : System.Word;
      cps             : System.Word;
      Frei            : array [52 .. 128] of Byte;
    end;

{$ifndef OS2}
var
  NilGrpToNetGrp  : GrpToNetGrpTyp absolute 0: 0;
  NilNetGrpInfo   : NetGrpInfoTyp absolute 0: 0;
  NilBoxen        : BoxenArray absolute 0: 0;
  NilGateWay      : GateWayTyp absolute 0: 0;
  NilDirectToBox  : DirectToBoxTyp absolute 0: 0;
  NilGrpInfo      : GrpInfoTyp absolute 0: 0;
  NilBoxGruppe    : BoxGruppenArray absolute 0: 0;
{$else}
var
  NilGrpToNetGrp  : GrpToNetGrpTyp;
  NilNetGrpInfo   : NetGrpInfoTyp;
  NilBoxen        : BoxenArray;
  NilGateWay      : GateWayTyp;
  NilDirectToBox  : DirectToBoxTyp;
  NilGrpInfo      : GrpInfoTyp;
  NilBoxGruppe    : BoxGruppenArray;
{$endif}

var
  GrpToNetGrp     : GrpToNetGrpTyp;
  { lokale Gruppe -> NetzGruppe; NoGrp: keine NetzGruppe }
var
  NetGrpInfo      : NetGrpInfoTyp;
  { "Box bekommt Gruppe direkt von uns";
   in ToBox[DirectBox[ThisBox]] stehen die Gruppen, die "wir hier" bekommen }
  { NetzGruppe -> lokale Gruppe; NoGrp: keine lokale Gruppe vorhanden }
  { soviele Mitteilungen gehen bers Netz, wenn die Verbindung
      "NeuImNetz" ist }
var
  Boxen           : ^ BoxenArray;
var
  Kuerzel         : ^ BoxenKuerzel;
  { Kuerzel darf nur benutzen, wer auch m7utilg.GetNetInfo aufruft!! }
var
  MaxDirectBox    : DirectBox; { Anzahl direkt angeschlossener Boxen }
  MaxBoxen        : Byte; { hchste MAUS-Nummer }
  ThisLevel       : Byte; { auf welcher Ebene ? }
  GateWay         : ^ GateWayTyp;
{$ifndef MAUS}
  DirectToBox     : DirectToBoxTyp;
  GrpInfo         : GrpInfoTyp;
  path            : FileStr;
  WillGruppe      : ^ BoxGruppenArray;
  BekommtGruppe   : ^ BoxGruppenArray;
{$endif}
  ConfPath,
  NetIOPath       : PathStr;

procedure CalcCrc(var crc: System.Word; var obj; Size: System.Word);

function BoxName(b: Box): tKuerzel;

{ function MakeName(b: Box): string; }
function MakeNameNeu(b: Box): string;
function MakeNameNeuK(const kz: string): string;

function NetConfigEinlesen(TestCfg: Boolean; var GrpToNetGrp: GrpToNetGrpTyp;
    var NetGrpInfo: NetGrpInfoTyp; var Boxen: BoxenArray; var GateWay:
    GateWayTyp; var DirectToBox: DirectToBoxTyp; var GrpInfo: GrpInfoTyp; var
    WillGruppe, BekommtGruppe: BoxGruppenArray): Boolean;

{$ifndef MAUS}
procedure NetConfigSchreiben(TestCfg: Boolean); { fr mnConfig }

procedure GrpInfoSchreiben;   { nur fr zentrale Gruppenverwaltung }

procedure NetConfigSchreibenSchnell(TestCfg: Boolean); { fr MausNet }
{$endif}

procedure GetBoxGrpRec(b: Box; var BoxGrp: tGruppenSet);
procedure PutBoxGrpRec(b: Box; var BoxGrp: tGruppenSet);
{ Lesen und Schreiben der Boxweisen Gruppenbestellungs-Infos }

implementation

function BoxName(b: Box): tKuerzel;
begin
  if b = 0 then
    BoxName := '#0'
  else
    if assigned(Kuerzel) then
      BoxName := Kuerzel^[b]
    else
      if assigned(Boxen) then
        BoxName := Boxen^[b].Kuerzel
      else
        RunError(95);
end;

(* obsolet, braucht keiner mehr -- hoffe ich...
function MakeName(b: Box): string;
const
  Hex             : array [0 .. $F] of Char= '0123456789abcdef';
var
  n               : string[2];
begin
{ Datei fr Box 3: MN-03.*;
    allgemein: MN-nn in hex }
  n := 'nn';
  n[1] := Hex[b shr 4];
  n[2] := Hex[b and $F];
  MakeName := MausNetPath + 'MN-' + n;
end {MakeName};
*)

function MakeNameNeu(b: Box): string;
begin
  MakeNameNeu := ConfPath + BoxName(b);
end;

function MakeNameNeuK(const kz: string): string;
begin
  MakeNameNeuK := ConfPath + kz;
end;

procedure CalcCrc(var crc: System.word; var obj; Size: System.Word);
var
  d,
  e,
  temp            : Byte;
  i               : Word;
  buf             : array [0 .. System.MaxInt] of Byte absolute obj;
begin
  {$r-}
  if size = 0 then
    exit;
  d := (crc shr 8) and $FF;
  e := crc and $FF;
  for i := 0 to Size - 1 do begin
    temp := buf[i] xor d;
    temp := (temp xor (temp shr 4)) and $FF;
    d := ((temp shl 4) xor (temp shr 3) xor e) and $FF;
    e := (temp xor (temp shl 5)) and $FF;
  end;
  Crc := d shl 8 + e;
  {$r+}
end {CalcCrc};

function NetConfigEinlesen(TestCfg: Boolean; var GrpToNetGrp: GrpToNetGrpTyp;
    var NetGrpInfo: NetGrpInfoTyp; var Boxen: BoxenArray; var GateWay:
    GateWayTyp; var DirectToBox: DirectToBoxTyp; var GrpInfo: GrpInfoTyp; var
    WillGruppe, BekommtGruppe: BoxGruppenArray): Boolean;
var
  f               : file;
  b               : Box;
  MiscInfo        : MiscInfoTyp;
  g               : NetzGruppe;
  tmp             : Word;
  avail           : Longint;
begin {NetConfigEinlesen}
  NetConfigEinlesen := True;
  if TestCfg then
    IO(OpenFile(f, fmReadAlone, MausNetPath + MausNetTstFile, 1))
  else
    IO(OpenFile(f, fmReadAlone, MausNetPath + MausNetDatFile, 1));
  BlockRead(f, MiscInfo, SizeOf(MiscInfo));
  if @NetGrpInfo = nil then
    Seek(f, FilePos(f) + SizeOf(NetGrpInfo[1]^) * (DefGrpMax + 1))
  else
    for g := 0 to DefGrpMax do begin
      avail := MaxAvail;
      if (avail >= SizeOf(NetGrpInfo[g]^)) then begin
        New(NetGrpInfo[g]);
        BlockRead(f, NetGrpInfo[g]^, SizeOf(NetGrpInfo[g]^));
      end
      else begin { nicht mehr genug Speicher: abbrechen! }
        for tmp := g - 1 downto 0 do begin
          Dispose(NetGrpInfo[tmp]);
          NetGrpInfo[tmp] := nil;
        end;
        NetConfigEinlesen := False;
        IO(CloseFile(f));
        Exit;
      end;
    end {for g:=0 to DefGrpMax};
  if @Boxen = nil then
    Seek(f, FilePos(f) + SizeOf(Boxen))
  else
    BlockRead(f, Boxen, SizeOf(Boxen));
  if @WillGruppe = nil then
    Seek(f, FilePos(f) + SizeOf(WillGruppe))
  else
    BlockRead(f, WillGruppe, SizeOf(WillGruppe));
  if @BekommtGruppe = nil then
    Seek(f, FilePos(f) + SizeOf(BekommtGruppe))
  else
    BlockRead(f, BekommtGruppe, SizeOf(BekommtGruppe));
  if @GrpToNetGrp = nil then
    Seek(f, FilePos(f) + SizeOf(GrpToNetGrp))
  else
    BlockRead(f, GrpToNetGrp, SizeOf(GrpToNetGrp));
  if @GateWay = nil then
    Seek(f, FilePos(f) + SizeOf(GateWay))
  else
    BlockRead(f, GateWay, SizeOf(GateWay));
  if @DirectToBox = nil then
    Seek(f, FilePos(f) + SizeOf(DirectToBox))
  else
    BlockRead(f, DirectToBox, SizeOf(DirectToBox));
  IO(CloseFile(f));
  MaxDirectBox := MiscInfo.MaxDirectBox;
  MaxBoxen := MiscInfo.MaxBoxen;
  ThisBox := MiscInfo.ThisBox;
  if (ThisBox <> 0) and (@Boxen <> nil) then
    ThisLevel := Min(Boxen[ThisBox].Ebene, 5); { z.Zt. nur 5 Ebenen }
  if @GrpInfo <> nil then begin
    IO(OpenFile(f, fmReadAlone, MausNetPath + NetGrpFile, 1));
    for g := 0 to DefGrpMax do begin
      avail := MaxAvail;
      if (avail < SizeOf(GrpInfo[g]^)) then begin
        for tmp := g - 1 downto 0 do begin
          Dispose(GrpInfo[tmp]);
          GrpInfo[tmp] := nil;
        end;
        IO(CloseFile(f));
        Write(Log, ' noITG ');
        NetConfigEinlesen := False;
        Exit;
      end
      else
        New(GrpInfo[g]);
      {$i-}
      BlockRead(f, GrpInfo[g]^, SizeOf(GrpInfo[g]^));
      {$i+}
      if IOResult = 100 then begin
        FillChar(GrpInfo[g]^, SizeOf(GrpInfo[g]^), 0);
        BlockWrite(f, GrpInfo[g]^, SizeOf(GrpInfo[g]^));
      end;
      tmp := GrpInfo[g]^.crc;
      GrpInfo[g]^.crc := 0;
      CalcCrc(GrpInfo[g]^.crc, GrpInfo[g]^, SizeOf(GrpInfo[g]^));
      if GrpInfo[g]^.crc <> tmp then begin
        WriteLn(Log, 'File defekt: ', MausNetPath + NetGrpFile);
        RunError(91);
      end;
      if (g > 0) and (GrpInfo[g]^.Name = '') then begin
        { leere Netzgruppen auf nichts zeigen lassen }
        Dispose(GrpInfo[g]);
        GrpInfo[g] := nil;
      end;
    end {for g:=0 to DefGrpMax};
    IO(CloseFile(f));
  end {if@GrpInfo<>nil};
end {NetConfigEinlesen};

{$ifndef MAUS}
procedure NetConfigSchreiben(TestCfg: Boolean);
var
  f               : file;
  MiscInfo        : MiscInfoTyp;
  g               : NetzGruppe;
begin
  FillChar(MiscInfo, SizeOf(MiscInfo), 0);
  MiscInfo.ThisBox := ThisBox;
  MiscInfo.MaxBoxen := MaxBoxen;
  MiscInfo.MaxDirectBox := MaxDirectBox;
  if TestCfg then
    Assign(f, MausNetPath + MausNetTstFile)
  else
    Assign(f, MausNetPath + MausNetDatFile);
  Rewrite(f, 1);
  BlockWrite(f, MiscInfo, SizeOf(MiscInfo));
  for g := 0 to DefGrpMax do
    BlockWrite(f, NetGrpInfo[g]^, SizeOf(NetGrpInfo[g]^));
  BlockWrite(f, Boxen^, SizeOf(Boxen^));
  BlockWrite(f, WillGruppe^, SizeOf(WillGruppe^));
  BlockWrite(f, BekommtGruppe^, SizeOf(BekommtGruppe^));
  BlockWrite(f, GrpToNetGrp, SizeOf(GrpToNetGrp));
  BlockWrite(f, GateWay^, SizeOf(GateWay^));
  BlockWrite(f, DirectToBox, SizeOf(DirectToBox));
  IO(CloseFile(f));
  if not TestCfg then
    NetConfigSchreiben(True);
  { Wenn ernst, auch Spielversion setzen }
end {NetConfigSchreiben};

procedure GrpInfoSchreiben;
{ nur fr zentrale Gruppenverwaltung }
var
  f               : file;
  g               : NetzGruppe;
  GrpInfoLeer     : GrpInfoRec;
begin
  Assign(f, MausNetPath + NetGrpFile);
  Rewrite(f, 1);
  FillChar(GrpInfoLeer, SizeOf(GrpInfoLeer), 0);
  for g := 0 to DefGrpMax do begin
    if GrpInfo[g] <> nil then begin
      GrpInfo[g]^.crc := 0;
      CalcCrc(GrpInfo[g]^.crc, GrpInfo[g]^, SizeOf(GrpInfo[g]^));
      BlockWrite(f, GrpInfo[g]^, SizeOf(GrpInfo[g]^));
    end
    else
      BlockWrite(f, GrpInfoLeer, SizeOf(GrpInfoLeer));
  end;
  IO(CloseFile(f));
end {GrpInfoSchreiben};

procedure NetConfigSchreibenSchnell(TestCfg: Boolean);
var
  f               : file;
  g               : NetzGruppe;
begin
  if TestCfg then
    IO(OpenFile(f, fmWriteAlone, MausNetPath + MausNetTstFile, 1))
  else
    IO(OpenFile(f, fmWriteAlone, MausNetPath + MausNetDatFile, 1));
  Seek(f, SizeOf(MiscInfoTyp));
  for g := 0 to DefGrpMax do
    BlockWrite(f, NetGrpInfo[g]^, SizeOf(NetGrpInfo[g]^));
  IO(CloseFile(f));
  if not TestCfg then
    NetConfigSchreibenSchnell(True);
  { Wenn ernst, auch Spielversion setzen }
end {NetConfigSchreibenSchnell};
{$endif}

procedure GetBoxGrpRec(b: Box; var BoxGrp: tGruppenSet);
var
  f               : file of tGruppenSet;
begin
  Assign(f, MausNetPath + BoxGrpFile);
  Reset(f);
  Seek(f, b - 1);
  Read(f, BoxGrp);
  Close(f);
end;

procedure PutBoxGrpRec(b: Box; var BoxGrp: tGruppenSet);
var
  f               : file of tGruppenSet;
  dummy           : tGruppenSet;
  b2              : Box;
begin
  Assign(f, MausNetPath + BoxGrpFile);
  {$i-}
  Reset(f);
  {$i+}
  if not IO2(ChkIO(f)) then begin
    WriteLn(Log, 'BoxGrpFile fehlt - wird neu [leer] angelegt');
    Rewrite(f);
    FillChar(dummy, SizeOf(dummy), 0);
    for b2 := 1 to DefBoxenMax do
      Write(f, dummy);
    Reset(f);
  end;
  Seek(f, b - 1);
  Write(f, BoxGrp);
  Close(f);
end {PutBoxGrpRec};

begin {mnDef}
  ModInit('mnDef');
  Boxen := nil;
  Kuerzel := nil;
  DrawConfigLine('Netz-Pfade');
  GetConfigPath(ConfPath, 'BoxConfPath', MausNetPath + 'Conf\', True);
  GetConfigPath(NetIOPath, 'NetIOPath', MausNetPath + 'IO\', True);
  {$ifdef OS2}
  FillChar(NilGrpToNetGrp, SizeOf(GrpToNetGrpTyp),0);
  FillChar(NilNetGrpInfo, SizeOf(NetGrpInfoTyp),0);
  FillChar(NilBoxen, SizeOf(BoxenArray),0);
  FillChar(NilGateWay, SizeOf(GateWayTyp),0);
  FillChar(NilDirectToBox, SizeOf(DirectToBoxTyp),0);
  FillChar(NilGrpInfo, SizeOf(GrpInfoTyp),0);
  FillChar(NilBoxGruppe, SizeOf(BoxGruppenArray),0);
  {$endif}
end.
