
{$A-,B-,E-,N-,R-,S-,V-}

{ kh 20.2.89 }

unit mnLog;

interface

uses
  Dos,
  mnDef,
  m7dec,
  m7config,
  m7time,
  m7utilg,
  Crt
  {$ifdef OS2}
  ,use32
  {$endif};

const
  LogFile         = 'MausNet.Log';

var
  FlushLog: boolean;
var
  DiskLog         : Text;
  WithTime        : boolean;

procedure InitNetLog;

procedure WritelnLog;

procedure GetHeap(var p; len: word);

procedure FreeHeap(var p; len: word);


implementation

var
  NewLine         : Boolean;
  OldExit         : Pointer;
  DontScroll,
  DontScrollNow   : Boolean;
  OpenLogDate     : integer;

{$f+}
procedure RenameLog(Date: integer);
var
  OldLog: file;
begin
  { LogFile ist nicht von heute: als MNLOG.WO sichern }
  {$I-}
  assign(OldLog, LogPath + 'mnLog.' + wochentagstr(Date));
  erase(OldLog);
  if IOresult > 0 then { es existierte wohl nicht };
  {$I+}
  assign(OldLog, LogPath + LogFile);
  Rename(OldLog, LogPath + 'mnLog.' + wochentagstr(Date));
end;

function OpenLog(var M: TextRec): Integer;
var
  DT: LongInt;
  LogDate: integer;
  s: string;
begin {|OpenLog}
  OpenLog := 0;
  with M do begin
    case Mode of
      {  ^^^^ hier gibt's einen Range Check, wenn man $R+ sagt ... }
      fmInput: OpenLog := 12;
      fmOutput: begin
          {$I-}
          assign(DiskLog, LogPath + LogFile);
          reset(DiskLog);
          {$I+}
          if IOresult=0 then begin
            { altes Logfile vorhanden }
            GetFTime(DiskLog,DT);
            LogDate := TageSeit(FileDateToMaus(DT));
            if LogDate<>today then begin
              close(DiskLog);
              RenameLog(LogDate);
              rewrite(DiskLog);
            end else
              { ans alte LogFile anfgen }
              append(DiskLog);
          end else
            rewrite(DiskLog);
        end;
      fmInOut: append(DiskLog);
    end {|case Mode};
    Mode := fmOutput;
  end {|with M};
  NewLine := false;
  OpenLogDate := today;
end {|OpenLog};

function WriteLog(var M: TextRec): Integer;
var
  buf             : string;
begin {|WriteLog}
  if NewLine and WithTime then { Am Zeilenanfang }
    write(DiskLog, GetTime, '>');
  with M do
    if BufPos > 0 then begin
      Move(BufPtr^, buf[1], BufPos);
      buf[0] := Chr(BufPos);
      BufPos := 0;
      write(DiskLog, buf);
      NewLine := buf[length(buf)] = #$0A;
      if newline and flushlog then begin
        close(disklog);
        append(disklog);
      end;
      if NewLine then begin
        if DontScrollNow then begin
          dec(buf[0]); { kein LF ausgeben }
          DontScrollNow := false;
        end;
      end;
      write(buf);
    end {|if BufPos>0};
  WriteLog := 0;
end {|WriteLog};

function CloseLog(var M: TextRec): Integer;
begin {|CloseLog}
  if TextRec(DiskLog).Mode <> fmClosed then begin
    Close(DiskLog);
    if OpenLogDate <> GetDateInt then
      RenameLog(OpenLogDate);
  end;
  CloseLog := 0;
end {|CloseLog};

procedure InitNetLog;
begin {|mnLog}
  {$I-}
  close(log);
  if IOResult<>0 then {nix};
  {$I+}
  WithTime := true;
  DontScrollNow := false;
  with TextRec(Log) do begin
    FillChar(Log, SizeOf(Log), $FF);
    Mode := fmClosed;
    BufSize := SizeOf(Buffer);
    BufPtr :=@Buffer;
    OpenFunc :=@OpenLog;
    InOutFunc :=@WriteLog;
    FlushFunc :=@WriteLog;
    CloseFunc :=@CloseLog;
    Name[0] := #0;
  end {|with TextRec(Log)};
  rewrite(Log);
  writeln(Log);
  writeln(Log, 'MausNet Log vom ', GetDate, ' ', GetTime);
end;

procedure WritelnLog;
begin
  if DontScroll then DontScrollNow := true;
  writeln(log);
end;

{--- Heap-Check ---}

type
  StackRec = record
            OldBP: Word;
            RetAdr: Pointer;
          end;
var
  BaseAddr: pointer;
  StackOff: word;


const
  MinAvail: LongInt = 16384; { Bei Unterschreitung Protokoll im Log }

procedure SaveStackAddr; { speichert die Return-Adresse }
{$ifndef OS2}
  inline($89/$2E/StackOff); { mov [StackOff],bp }
{$else}
asm
   mov [Stackoff], ebp
end;
{$endif}

procedure GetHeap(var p; len: word);
var
  StackPtr: ^StackRec;
  CallAddr: pointer;
begin
  SaveStackAddr;
  GetMem(pointer(p), len);
  {$ifndef OS2}
  if MaxAvail<MinAvail then begin
    MinAvail := MaxAvail;
    StackPtr:=Ptr(SSeg, StackOff);
    CallAddr:=StackPtr^.RetAdr;
    writeln(log, 'GetHeap (',HexPtr(CallAddr),'):', len:7,', frei:',
            MaxAvail:7,MemAvail:7);
  end;
  {$endif}
end;

procedure FreeHeap(var p; len: word);
begin
  FreeMem(pointer(p), len);
end;

begin
  flushlog := GetConfigBoolean('FlushLog', false);
  InitNetLog;
  DontScroll := GetConfigBoolean('DontScroll', true);
end {|mnLog}.
