{ MNMAIN.PAS - bergeordnete Routinen }

unit mnMain;

{$A-,B-,E-,N-,R+,S+,V-}

INTERFACE
{$ifdef MausNet}
uses
  crt,dos,
  m7utillo,m7config,m7dec,m7time,m7disk,m7utilg,m7msg,m7RawIni,
  mnDef,m7Raw,mnLog,mnAnruf,mnMittHi,mnUtil
  {$ifdef OS2} ,use32 {$endif};
{$endif}
const
  VersNr  : string[15] = '2.60' +
            {$ifdef Debug} '/debug' + {$endif}
            {$ifdef dpmi} '/dpmi' + {$endif}
            {$ifdef OS2}  '/OS2'+   {$endif}
            { + '/alpha' } '';
  VersDat : string[8]  = '04.01.98';
{$ifdef MausNet}
procedure Main;
{$endif}

IMPLEMENTATION
{$ifdef MausNet}
var
  AbAllg,AbPers: word;
  TimeOutZeit: integer;
  DoExport: boolean;

procedure TestParams(var mode: MausNetMode; var ToBoxen: BoxSet);
var
  b: Box;
  Param: string[40];
  pn, diff, err, i: integer;

  function InputWord(s: string): word;
  var
    ok: boolean;
    inp: string;
    num: word;
    err: integer;
  begin
    write(s);
    InputWord := 0;
    repeat
      readln(inp);
      if inp='' then exit;
      val(inp, num, err);
    until (err=0);
    InputWord := num;
  end;

  function FindMAUS(s: string): Box;
  var
    found: boolean;
    b: Box;
  begin
    found:=false;
    b:=0;
    repeat
      inc(b);
      with Boxen^[b] do begin
        if Kuerzel = s then
          found := (UeberMir or UnterMir) and (not FremdBox);
      end;
    until found or (b>=MaxBoxen);
    if found then begin
      FindMAUS := b;
    end else begin
      {-- falscher Parameter }
      writeln(Log,'MAUS ',s,': keine Verbindung mglich !',#7);
      FindMAUS := 0;
    end;
  end;

  function GetBoxSet(Param: string; var BoxS: BoxSet): boolean;
  { wertet einen oder mehrere Box-Angaben aus. Return TRUE = ok }
  var
    b: Box;
    p: integer;
    s: string[20];
  begin
    GetBoxSet := false;
    Boxs := [];
    while Param <> '' do begin
      p := pos(',', Param);
      if p = 0 then p := length(Param) + 1;
      s := copyL(Param, p-1);
      b := FindMaus(s);
      if b = 0 then exit;
      Boxs := Boxs + [b];
      delete(Param, 1, p);
    end;
    GetBoxSet := true;
  end;

  procedure WrongParam;
  begin
    writeln(log, 'Falscher Parameter "', Param, '" - Abbruch!');
    halt;
  end;

  procedure SetMode(m: MausNetMode);
  begin
    if mode <> NilMode then WrongParam; { Mode schon gesetzt }
    mode := m;
  end;

  procedure HelpScreen;
  begin
    writeln;
    writeln('MausNet-Aufrufparameter:');
    writeln;
    writeln('MausNet               Nchtliches MausNet');
    writeln('MausNet /1            1. Teil des Nachtnetz bis Anruf nach oben');
    writeln('MausNet /2            2. Teil des Nachtnetz ab Anruf von oben');
    writeln('MausNet /e            Erwarte einen Anruf');
    writeln('MausNet /e:HB         Erwarte Anruf aus HB (packt nur fr HB)');
    writeln('MausNet /c            bernehme Verbindung von MAUS (Event 70)');
    writeln('MausNet /m            Mache Anruf nach oben');
    writeln('MausNet AC            Mache Anruf bei MAUS AC');
    writeln('MausNet K2,MS         Mache Anruf bei K2 und MS');
    writeln('MausNet Import        Importiert im MausNet-Pfad liegende Datenfiles');
    writeln('MausNet Export        Exportiert neue Msgs an angeschlossene Muse');
    writeln('MausNet Export?       Exportiert eigene Msgs ab anzugebender MsgId');
    writeln;
    writeln('Zustzliche Parameter:');
    writeln;
    writeln('MausNet .. /x         Lokale Mitteilungen diesmal nicht exportieren');
    writeln('MausNet .. /t:21:00   TimeOut um 21:00 (Default jetzt +30 Min.)');
    writeln('MausNet .. /t+15      TimeOut in 15 Minuten');
    writeln('MausNet .. /p:1       Anruf auf Modemport 1');
    writeln;
    writeln('Beispiel: MausNet AC3 /x /t:20:20');
    halt;
  end;

begin { TestParams }
  Nachtmodus := Nacht;
  if ParamCount = 0 then
    mode := NachtNetz
  else begin
    mode := NilMode;
    for pn := 1 to ParamCount do begin
      Param := ParamStr(pn);
      UpString(Param);
      if Param[1] = '-' then Param[1] := '/';
      if Param[1] = '/' then begin
        {--- Kommando-Parameter auswerten }
        if Param[2] = 'E' then begin { '/E:AC' }
          SetMode(ErwarteAnrufe);    {  12345  }
          if (length(Param) > 2) and (Param[3]=':') then begin
            if not GetBoxSet(CopyR(Param, 4), ToBoxen) then
              WrongParam;
          end else
            ToBoxen := [];
        end else if Param[2] = 'T' then begin
          {--- TimeOut-Zeit /T:21:15 oder /T+15 }
          if (length(Param) = 8) and (Param[3]=':') then begin
            TimeOutZeit := MinutenSeit(CopyR(Param, 4));
          end else if (param[3]='+') then begin
            val(CopyR(Param, 4), diff, err);
            if err > 0 then WrongParam;
            TimeOutZeit := GetTimeInt + diff;
          end else
            WrongParam;
        end else if Param[2] = 'P' then begin { /P:1 }
          if (length(Param) = 4) and (Param[3] = ':') then begin
            i := ord(Param[4]) - ord('0');
            if (i < 1) or (i > ModemPorts) then WrongParam;
            ForcePort := i;
          end else
            WrongParam;
        end else begin
          { Einzelbuchstaben-Parameter }
          if length(Param) <> 2 then WrongParam;
          case Param[2] of
            'C': SetMode(VerbindungUebernehmen);
            '1': begin
                   SetMode(NachtNetz); NachtModus := Nacht1;
                 end;
            '2': begin
                   SetMode(NachtNetz); NachtModus := Nacht2;
                 end;
            'M': begin
                   SetMode(MacheAnrufe);
                   b:=1;
                   ToBoxen := [];
                   repeat
                     {--- Box ber mir suchen }
                     if Boxen^[b].UeberMir then
                       ToBoxen := [b];
                     inc(b);
                   until (b > MaxBoxen);
                   if ToBoxen = [] then
                     WrongParam;
                 end;
            'X': DoExport := false;
            '?',
            'H': HelpScreen;
            else WrongParam;
          end;
        end;
      end else begin
        {--- Parameter ohne Schrgstrich: Import, Export, BoxName }
        if Param='IMPORT' then begin
          SetMode(NurImport);
        end else
        if Param='EXPORT' then begin
          SetMode(NurExport);
        end else
        if Param='EXPORT?' then begin
          SetMode(NurExport);
          writeln('Export lokaler Msgs ab bestimmter Nummer (MsgId)');
          writeln;
          writeln('Bitte NUR die Nummer eingeben, bei 12345@AC also 12345');
          writeln('Leereingabe steht fr neu eingetragene Msgs');
          writeln;
          AbAllg := InputWord('Allg-Msgs ab: ');
          AbPers := InputWord('Pers-Msgs ab: ');
          writeln;
          if AbAllg>0 then
            writeln(log,'Export Allg ab ',AbAllg,'@',BoxName(ThisBox));
          if AbPers>0 then
            writeln(log,'Export Pers ab ',AbPers,'@',BoxName(ThisBox));
          delay(1000);
        end else begin
          {--- Parameter ohne Schrgstrich: BoxName [evtl. ,BoxName] ? }
          if not GetBoxSet(param, ToBoxen) then
            WrongParam;
          SetMode(MacheAnrufe);
        end;
      end;
    end;
  end;
end;

procedure Main;
var
  ToBoxen: BoxSet;
  c, p: byte;
  Name: PathStr;
  ParFile: file;
  s: string;
  g: Netzgruppe;
  db: DirectBox;
begin
  { InitNetLog; }

  CheckBreak := true;
  ClrScr;
  writeln;
  writeln;
  writeln('>>> MausNet (R) Version ', VersNr, ' vom ', VersDat, ' <<<');
  writeln;
  writeln('Copyright (c) 1989-97 by Jrg Stattaus');
  writeln;
  writeln;

  new(Boxen);
  new(Gateway);
  NetConfigEinlesen(false, GrpToNetGrp, NetGrpInfo, Boxen^, GateWay^,
    DirectToBox, NilGrpInfo, NilBoxGruppe, NilBoxGruppe);
  {$ifdef Debug}
    writeln(Log);
    writeln(Log, 'Netzgruppenliste:');
    writeln(Log);
    write(Log, 'Netz -> ToGrp');
    for db := 0 to MaxDirectBox do
      write(Log, ' Box', db);
    writeln(Log);
    writeln(Log);
    for g := 1 to DefGrpMax do begin
      write(Log, g:4, ' -> ', NetGrpInfo[g]^.ToGrp:5);
      for db := 0 to MaxDirectBox do
        if NetGrpInfo[g]^.ToBox[db] = ImNetz then
          write(Log, '  ja ') else write(Log, '  -  ');
      writeln(Log);
    end;
    writeln(Log);
  {$endif}

  writeln(Log);
  writeln(Log);
  with Boxen^[ThisBox] do begin
    writeln(Log,'Version: ',VersNr,' (MAUS-Units ',Version,')');
    writeln(Log,'MAUS   : ',Name,', ',BoxName(ThisBox));
    writeln(Log,'Nummer : ',Nummer1);
    writeln(Log,'MausDir: ',MausPath);
    writeln(Log,'NetDir : ',MausNetPath);
    writeln(Log);
    writeln(Log);
  end;

  MoreFiles;
  { CloseConfig; geht nicht mehr hier wegen MaskGate in .EXP-Erzeugung}

  TestParams(NetMode, ToBoxen);
  SysopProtInit; { in 2.05 hierhin. Keine Ahnung, warum vorher unten }

  s := 'MausNet Version ' + VersNr;
  if ParamCount > 0 then begin
    s := s + ' mit Parameter "';
    for p := 1 to ParamCount do begin
      if p > 1 then s := s + ' ';
      s := s + ParamStr(p);
    end;
    s := s + '"';
  end;
  SysopProt(s + ' gestartet');
  SysopProt('');

  AnrufInit;

  if NetMode = Nachtnetz then SetPhasenLimits;
  if (not NoModem) and
    (not (NetMode in [NurImport, NurExport])) then
      ModemInit;

  if Boxen^[ThisBox].Nummer1 = '0' then begin
    SysopProt('Keine eigene Tel-Nr in MN-nn.CNF angegeben.');
    halt;
  end;

  if NetMode<>VerbindungUebernehmen then InitMsgFiles; { Index aufbauen }
  UtilInit;
  OldVersion := MausVar.MausNetVer;
  if OldVersion <> CopyL(VersNr, min(length(VersNr), 10)) then begin
    MausVar.MausNetVer := VersNr;
    WriteMausVar;
    SysopLog('MausNet (R) Version '+ VersNr + ' neu installiert.');
  end;
  writeln(Log);

  if NetMode <> VerbindungUebernehmen then
    LookForOldImports;
  if NetMode = Nachtnetz then begin
    TimingInit;
    if NachtModus <> Nacht2 then
      Tim.T[AEx] := GetSecondInt;
  end;
  if not (NetMode in [NurImport, VerbindungUebernehmen])
  and (NachtModus <> Nacht2) and DoExport then begin
    writeln(Log,'Phase 0: Export eigener Mitteilungen');
    ExtrahiereEigeneMitteilungen(AbAllg, AbPers);
  end;
  CloseConfig;

  if (not (NetMode in [NurImport, NurExport])) and NoModem then begin
    SysopLog('Kein Modem konfiguriert.');
    halt;
  end;

  CostLogInit;
  writeln(Log);
  case NetMode of
    Nachtnetz: begin
        {--- normale MausNet-Session }
        MacheNachtnetz;
      end;
    MacheAnrufe: begin
        {--- eine/mehrere Verbindung(en) nach ToBox }
        writeln(Log, 'Mache Anruf(e) nach ',BoxList(ToBoxen));
        MultiVerbindungZu(ToBoxen, TimeOutZeit);
      end;
    ErwarteAnrufe: begin
        {--- Einzel-Verbindung von ??Box }
        writeln(Log, 'Erwarte einen/mehrere Anruf(e)');
        MultiVerbindungVon(ToBoxen, TimeOutZeit);
      end;
    VerbindungUebernehmen: begin
        {--- einen Anruf von der MAUS bernehmen }
        writeln(Log,'bernehme einzelnen Anruf');
        UebernehmeAnruf;
      end;
    NurExport: begin
        { schon fertig ... }
      end;
  end;
  writeln(Log);
  writeln(Log,'MausNet regulr beendet.');
  CloseExportFiles;
end;

begin
  { VersNr als ZweiZeichen-String: 1.10 -> [02] : #01 #10 }
  VersStr := chr(StrToInt(VersNr[1])) + chr(StrToInt(copy(VersNr,3,2)));
  ProgVersion := 'MausNet (R) '+ VersNr + ' vom ' + VersDat;
  AbAllg := 0;
  AbPers := 0;
  TimeOutZeit := 0;
  DoExport := true;
{$endif}
end.

