{ MNMITT.PAS - Mitteilungen in/ex }

unit mnMitt;

{$A-,B-,E-,N-,V-}

{$L+}

INTERFACE

uses
  crt,dos,m7utillo,m7config,
  m7dec,m7time,m7disk,m7utilg,m7msg,
  mnDef,mnLog,mnUtil
  {$ifdef OS2} ,use32 {$endif};

var { gemeinsame Vars/Procs fr MitteilungEx und MitteilungenReExport }
  GetMemLen: word;
  NetPar: NetzMittParameter;
  Konvertiert: boolean;
  DataNeu,DataPtr: PDaten;
  SchonDa: boolean;

procedure AddMitteilung(b: box; var NetPar: NetzMittParameter; Data: PDaten);

procedure AddMitteilungExit;

function MitteilungAllgEx(var par: PParameterblock): boolean;

procedure MitteilungPersEx(var par: PParameterblock);

procedure MitteilungStatusEx(var par: PParameterblock);

{ procedure MitteilungenReExport; }

procedure ChangeLStatus(Stat: NetzStatus);


IMPLEMENTATION

{-------- eine Mitteilung in ExportFiles einer Box oder lokal zufgen --------}

var
  NetMsgNum: word;
  LangePersMsg: word;
  PMMassenFilter, PMMassenHinweis: LongInt;
  PMsum: record
          An, Von : AdrStr;
          Anz : system.word;
          Len : LongInt;
          ZuLang, GenMsg, First : boolean;
        end;

procedure GenPMMassenMsg;
{--- "Abschlubericht" bei PM-Massen abgeben }
var
  s: string;
begin
  with PMsum do begin
    s := 'PM-Massen: ' + IntToStr(Anz) + ' Msgs mit '
         + IntToStr(Len) + ' Bytes ';
    If ZuLang then  s := s + 'gefiltert' else s := s + 'transportiert';
    SysopProt(s);
    SysopProt('   von: ' + Von + ' an: ' + An);
    ZuLang := false; GenMsg := false; First := true;
  end;
end;

procedure AddMitteilung(b: box; var NetPar: NetzMittParameter; Data: PDaten);

  procedure TrageImNetzFileEin(b: Box; NetPar: NetzMittParameter; Data: PDaten);
  var
    NetParAlt: NetzMittParameter;
    found: boolean;
    db,dvon: DirectBox;
  begin
    db := Boxen^[b].Direct;
    if Boxen^[b].FremdBox then exit; { kommt nicht mehr vor }
    with ExportFiles[db] do begin
      {--- Files ffnen}
      OpenExportFile(db);
      with NetPar do begin
        {--- Screen-Log }
        write(log, Boxen^[b].Kuerzel,' ');
        {--- Daten zufgen}
        DatenOffset := FileSize(DatFile); { Offset im NetPar einsetzen }
        seek(DatFile,DatenOffset);
        BlockWrite(DatFile,Data^,Laenge);
        {--- Parameter zufgen}
        seek(ParFile,FileSize(ParFile));
        write(ParFile,NetPar);
        inc(Msgs);
        MsgStat(NetPar.Status, FromBox, b, NetPar.Laenge);
      end;
    end;
  end;

  {=== Auto-Msg-Support ===}

  var
    NetMsgPar: NetzMittParameter;
    NetMsgDat: PDaten;
    NetMsgPtr: integer;
    NetMsgBox: Box;

  procedure NetMsgOpen(ToBox: Box; Wg: string);
  begin
    FillChar(NetMsgPar,sizeof(NetMsgPar),0);
    with NetMsgPar do begin
      Status := 'P';
      inc(NetMsgNum);
      Id.Nummer := NetMsgNum;
      Id.Box := ThisBox;
      Stichwort := Wg;
    end;
    NetMsgBox := ToBox;
    NetMsgDat := GetDataPointer;
    NetMsgPtr := 0;
  end;

  procedure NetMsgWrite(s: string);
  begin
    move(s[1], NetMsgDat^[NetMsgPtr], length(s));
    inc(NetMsgPtr, length(s));
    NetMsgDat^[NetMsgPtr] := ord(cr);
    inc(NetMsgPtr, 1);
  end;

  procedure NetMsgClose;
  begin
    NetMsgPar.Laenge := NetMsgPtr;
    TrageImNetzFileEin(NetMsgBox, NetMsgPar, NetMsgDat);
  end;

  procedure TrageLokalEin;
  { Problem: Kommentare verketten }
  var
    Grp: tGruppe;
    DupeNum: word;
    pbDupe: pParameterblock;

    procedure MsgToFile;
    {--- Msg zu File konvertieren }
    const
      LegaleExtensions = '.EXP,.INF';
    type
      pGrpInfoRec = ^GrpInfoRec;
      pTimingTyp = ^TimingTyp;
      pGruppenSet = ^tGruppenSet;
    var
      FileName: PathStr;
      f: file;
      Dir: DirStr;
      Name: NameStr;
      Ext: ExtStr;
      ngf: file of GrpInfoRec;
      OldGrp: GrpInfoRec;
      NewGrp: pGrpInfoRec;
      GrpNum,err: integer;
      found: boolean;
      pTim: pTimingTyp;
      GrpLogMade: boolean;
      pGSet: pGruppenSet;
      b: Box;

      procedure GrpLog(s: string);
      var
        GrpNumStr: string[3];
      begin
        if not GrpLogMade then begin
          writeln(Log);
          GrpLogMade := true;
          str(GrpNum:3, GrpNumStr);
          SysopLog(GrpNumStr + ' ' + NewGrp^.Name + ':');
        end;
        SysopLog('    ' + s);
      end;

    begin { MsgToFile }
      with NetPar do begin
        FileName:=Stichwort;
        FSplit(FileName,Dir,Name,Ext);
        if Name='NETGRP' then begin
          {--- NET-GRP.DAT updaten }
          delete(Ext, 1, 1);
          val(Ext, GrpNum, err);
          if (err = 0) and (GrpNum >= 0) and (GrpNum <= DefGrpMax) then begin
            GrpLogMade := false;
            new(NewGrp);
            move(Data^, NewGrp^, sizeof(NewGrp^));
            write(log, 'NET-GRP.DAT: Update ',GrpNum:3,' ',NewGrp^.Name, ' ');
            assign(ngf, MausNetPath + NetGrpFile);
            reset(ngf);
            seek(ngf, GrpNum);
            read(ngf, OldGrp);
            seek(ngf, GrpNum);
            write(ngf, pGrpInfoRec(Data)^);
            close(ngf);
            if ThisBox in NewGrp^.BoxListe then begin
              { wenn hier erlaubt, Hinweis an Sysop }
              if OldGrp.Name = '' then begin
                GrpLog('(NEU)');
                GrpLog(NewGrp^.UserInfo);
              end else begin
                if (OldGrp.Name <> NewGrp^.Name) then
                  GrpLog('Name gendert');
                if OldGrp.UserInfo<>NewGrp^.UserInfo then
                  GrpLog(NewGrp^.UserInfo);
                if OldGrp.SysopInfo<>NewGrp^.SysopInfo then
                  GrpLog(NewGrp^.SysopInfo);
                if not (ThisBox in OldGrp.BoxListe) then
                  GrpLog('Jetzt auch hier konfigurierbar');
              end;
              if GrpLogMade then
                write(log, 'Update ',GrpNum:3,' ',NewGrp^.Name, ' ');
            end;
            dispose(NewGrp);
          end;
        end else if FileName = TimingFile then begin
          pTim := pTimingTyp(Data);
          write(log, BoxName(pTim^.IchBin), ' ', DatumSeit(pTim^.Datum));
          TimingAdd(pTim^, 0)
        end else if Ext = '.GRP' then begin
          b := FindBoxNum(Name);
          if b > 0 then begin
            pGSet := pGruppenSet(Data);
            PutBoxGrpRec(b, pGSet^);
            write(log, BoxName(ThisBox), ' ');
          end else
            write(log,'NICHT eingetragen ');
        end else begin
          if (Ext = '.EXP') and (CopyL(Name, 3) <> 'MN-') then
            FileName := ConfPath + FileName; { neues EXP bekommen }
          {--- einzelnes File zum Abspeichern }
          {$I-}
          assign(f,FileName);
          reset(f);
          found := IoResult=0;
          if found then close(f);
          {$I+}
          if (not found) or (pos(Ext,LegaleExtensions)>0) then begin
            { nicht da  oder  legale Extension -> berschreiben }
            rewrite(f,1);
            BlockWrite(f,Data^,Laenge);
            close(f);
            write(log,BoxName(ThisBox), ' ');
          end else
            write(log,'NICHT eingetragen ');
        end;
      end;
    end;

    procedure Eintragen;
    var
      pb,pbOld: PParameterBlock;

      procedure WorkOnPM;
      var
        DatPtr: pDaten;
        ZielBox, NetZielBox, ViaBox: Box;
        Von,An: AdrStr;
        GatewayDist: integer;
        direct: boolean;

        procedure PersMsgLokal(SchonGelesen: boolean);
        var
          Vorname, Nachname, NachAt: AdrStr;
          SucheErr: SucheAnTyp;
          pb2: pParameterblock;
        begin
          with pb^ do begin
            SucheErr := AnOk;
            if ZielBox<>ThisBox then begin
              EmpfaengerNummer := -1000-ViaBox
            end else begin
              if GatewayDist=0 then begin
                ParseAn(An, Vorname, Nachname, NachAt);
                EmpfaengerNummer := SucheAnLokal(Vorname, Nachname, SucheErr);
              end else
                Empfaengernummer := GatewayDist;
            end;
            if SchonGelesen then LStatus := 'G'
              else LStatus := 'N';
            LDatum := today;
            LZeit := GetTimeInt;
            write(log,'(User#',Empfaengernummer,') ');
            if SucheErr = AnOk then begin
              if FindNetMsg('P', NetPar.Id) <> 0 then begin
                write(log, 'schon da.')
              end else begin
                MsgEintragen('P', pb, Data, NetPar.laenge);
                Write(log,'#', pb^.Nummer);
                if pb^.MsgMinus <> 0 then begin
                  {--- Beantwortet-Status schon mal setzen }
                  pb2 := GetParameterExact('P', pb^.MsgMinus);
                  if pb2 <> nil then begin
                    with pb2^ do begin
                      LStatus := 'B';
                      LDatum := today;
                      LZeit := GetTimeInt;
                    end;
                    write(log, '<Beantwortet:', pb2^.Nummer, '>');
                    PutParameter(pb2, tsnNeu);
                  end;
                end;
                MsgStat('P', FromBox, ThisBox, NetPar.Laenge);
              end;
            end else begin
              { Adressat e. Netz-Msg nicht ok -> Antwort-Msg zurck ins Netz }
              (*
              NetZielBox := FindZielBox(Von, GatewayDist{ist hier egal}, direct);
              *)
              NetZielBox := NetPar.Id.Box;
              ViaBox := GetViaBox(NetZielBox);
              if ViaBox>0 then begin
                {--- Antwort-Msg an User schicken }
                write(log, ' Bounce -> ');
                NetMsgOpen (ViaBox, Stichwort);
                NetMsgPar.MinusId := NetPar.Id;
                { if direct then   KEINE Direktadr. wg. weitergegeb. Msgs
                  NetMsgPar.NetGrpB := NetZielBox; }
                NetMsgWrite('Von: MausNet @ '+BoxName(ThisBox)+GetMsgDate);
                NetMsgWrite('An : '+Von);
                NetMsgWrite('');
                case SucheErr of
                  AnUnbekannt: begin
                    NetMsgWrite('Empfnger '+An+' unbekannt!');
                    NetMsgWrite('User '+An+' unknown!');
                  end;
                  AnNichtEindeutig: begin
                    NetMsgWrite('Empfnger '+An+' nicht eindeutig!');
                    NetMsgWrite('User '+An+' not unique!');
                  end;
                  AnGruppeUnbekannt:
                    NetMsgWrite('Gruppe ' + Nachname + ' unbekannt!');
                end;
                NetMsgClose;
              end else
                SysopLog('Bounce an '+Von+' nicht mglich!');
            end;
          end;
        end;

        function FindDat(const SuchStr: string; var p: pDaten): boolean;
        var
          TestStr: string;
          ofs: integer;
        begin
          ofs := 0;
          while (ofs < 1000) { Sicherheitsbedingung } do begin
            if (char(p^[ofs]) = SuchStr[1]) then begin
              move(p^[ofs], TestStr[1], length(SuchStr));
              TestStr[0] := char(length(SuchStr));
              if UpStr(TestStr) = UpStr(SuchStr) then begin
                FindDat := true;
                inc(longint(p), ofs);
                exit;
              end;
            end;
            inc(ofs);
          end;
          FindDat := false;
        end;

      var
        UpperAn, MyBox: string[80];
        Blanks: string[10];
        Dat2: pDaten;
        PosBox: integer;
      begin { WorkOnPM }
        with pb^ do begin
          {--- persnliche Msg }
          Status := 'P';
          Write(log, 'P', MsgId(NetPar.Id), ' ');
          DatPtr := Data;
          GetAdrLines(DatPtr, Von, An);
          { writeln(log, 'NetGrpB:', NetPar.NetGrpB); }
          if NetPar.NetGrpB = 0 then
            ZielBox := FindZielBox(An, GatewayDist, direct)
          else if NetPar.NetGrpB = ThisBox then begin
            ZielBox := FindZielBox(An, GatewayDist, direct);
            { writeln(log, 'Zielbox:', Zielbox); }
            if ZielBox <> ThisBox then begin
              NetPar.NetGrpB := 0; { Direct routing aus! }
              { Msg war wahrscheinlich an "xyz@gateway-BOX", ist aber nicht
                zustellbar. Also rein in PersMsgLokal und dort Bounce }
              GatewayDist := 0;
              ZielBox := ThisBox;
            end else begin
              { Writeln(log, 'An:>', An, '<'); }
              UpperAn := UpStr(An);
              MyBox := '-' + BoxName(ThisBox);
              PosBox := LastPos(MyBox, UpperAn);
              { writeln(log, 'PosBox:', PosBox, '=?=', length(UpperAn), '-',
                length(MyBox), '+1'); }
              if PosBox = length(UpperAn) - length(MyBox) +1 then begin
                { -BOX kappen }
                Dat2 := Data;
                Blanks := '         ';
                if FindDat('An', Dat2) then begin
                  inc(longint(Dat2), PosBox);
                  if FindDat(MyBox, Dat2) then begin
                    Move(Blanks[1], Dat2^, length(MyBox));
                    write(log, '<', MyBox, ' weggepatcht> ');
                  end;
                end;
              end;
            end;
          end else
            ZielBox := NetPar.NetGrpB;
          {--- PM-Massen-Check }
          if (PMMassenHinweis > 0) or (PMMassenFilter > 0) then begin
            if (not PMsum.First) and (Von = PMsum.Von) and (An = PMsum.An) then begin
              {--- gleicher Absender/Empfnger - Inhalt checken }
              inc(PMsum.Anz);
              inc(PMsum.Len, NetPar.Laenge);
              PMsum.ZuLang := (PMsum.Len > PMMassenFilter);
              PMsum.GenMsg := PMsum.ZuLang or
                (PMmassenHinweis > 0) and (PMsum.Len > PMmassenHinweis);
            end else
              PMsum.First := true;
            if PMsum.First then begin
              if PMsum.GenMsg then GenPMMassenMsg;
              PMsum.Von := Von; PMsum.An := An; PMsum.Len := NetPar.Laenge;
              PMsum.Anz := 1; PMsum.First := false;
              PMsum.ZuLang := false; PMsum.GenMsg := false;
            end;
          end;
          write(log,'Von: ',Von,' an: ',An,' -> ');

          if NetPar.Laenge > LangePersMsg then begin
            {--- PersMsg berschreitet gewisse Lnge }
            write(log,' [',NetPar.Laenge,' Bytes] ');
          end;
          if PMsum.ZuLang then begin
            {--- PM-Massen zu lang geworden: an lokalen Sysop schicken }
            An := 'Sysop @ ' + BoxName(ThisBox);
            ZielBox := ThisBox; { einfach umsetzen }
            GatewayDist := 0;
          end;
          ViaBox := GetViaBox(ZielBox);
          if ZielBox in ThisAndFremd then begin
            { direkt an uns oder an eine Fremdbox unter uns }
            PersMsgLokal(PMsum.ZuLang);
              { Parameter: wenn PM-Massen, dann auf gelesen setzen }
            WritelnLog;
          end else begin
            if ZielBox=0 then begin
              writeln(log, ' = #0');
              SysopProt('PM an ' + An + ': NICHT zustellbar!');
            end else begin
              { if not PMsum.ZuLang then begin }
              if ViaBox>0 then begin
                { weiter zu dieser Box schicken }
                TrageImNetzFileEin(ViaBox, NetPar, Data);
                WritelnLog;
                if ViaBox = FromBox then
                  SysopLog('PM an ' + An + ': zurckgeroutet.');
              end else begin
                SysopProt('PM an ' + An + ': keine Verbindung!');
                writeln(log,'Keine Verbindung zur Adressat-Box!');
              end;
            end;
          end;
        end;
      end;

    begin {eintragen}
      GetHeap(pb, sizeof(pb^));
      FillChar(pb^, SizeOf(pb^), 0);
      with pb^ do begin
      { Nummer setzt PutData }
        Sendernummer := NetzMitt;
        Stichwort := NetPar.Stichwort;
        EDatum := today;
        EZeit := GetTimeInt;
        NetId := NetPar.Id;
        ReplyId := NetPar.MinusId;
        if NetPar.Status='P' then
          WorkOnPM
        else begin
          {--- allgemeine Msg }
          Status := 'A';
          AnGruppe := Grp;
          Distribution := NetPar.Distribution;
          ProfilerStart('MsgEin');
          MsgEintragen('A', pb, Data, NetPar.laenge);
          ProfilerEnde ('MsgEin');
          write(log,'#', pb^.nummer,' ');
          MsgStat('A', FromBox, ThisBox, NetPar.Laenge);
        end;
      end;
      FreeHeap(pb, sizeof(pb^));
    end;

  begin {TrageLokalEin}
    case NetPar.Status of
      'F': MsgToFile; { File als Msg verschickt }
      'P': Eintragen;
      else { 'A' } begin
        if PMsum.GenMsg then GenPMMassenMsg;
        Grp := NetGrpInfo[GetNetGrp(NetPar)]^.ToGrp;
        if Grp<>NoGrp then begin
          {--- wir haben hier diese Gruppe}
          {--- Aber haben wir vielleicht schon diese Mitteilung ? }
          if NetPar.Id.Box = ThisBox then begin
            writeln(log,'von hier!');
            SchonDa := true; { eliminiert Dupes }
          end else begin
            ProfilerStart('Dupcek');
            DupeNum := FindNetMsg('A', NetPar.Id);
            if DupeNum > 0 then begin
              pbDupe := GetParameterExact('A', DupeNum);
              SchonDa := (pbDupe^.Stichwort = NetPar.Stichwort);
              if not SchonDa then begin
                if ThisBox = 2 then
                  SysopProt('MsgId-Dupe '+ MsgId(NetPar.Id));
                write(log, '<MsgId-Dupe>');
              end;
            end;
            ProfilerEnde ('Dupcek');
            if not SchonDa then
              {--- nein: also eintragen }
              Eintragen
            else
              writeln(log,'schon da.');
          end;
        end;
      end;
    end;
  end;

begin { AddMitteilung }
  if b = ThisBox then TrageLokalEin
  else TrageImNetzFileEin(b, NetPar, Data);
end;

procedure AddMitteilungExit;
begin
  if PMsum.GenMsg then GenPMMassenMsg;
end;

{===================== EX: lokale Mitteilungen verteilen =====================}

  procedure InitNetPar(par: PParameterblock);
  begin
    with par^ do begin
      FillChar(NetPar,sizeof(NetPar),0);
      NetPar.Status := Status;
      NetPar.Id := NetId;
      NetPar.Stichwort := Stichwort;
    end;
    konvertiert:=false;
  end;

  procedure InitMitteilung(par: PParameterblock);
  {--- liest Mitteilung und setzt ggf. Distribution }
  var
    pbk: TParameterblock;
    pb: PParameterblock;
    OldNum, g: word;
  begin
    with par^ do begin
      DataPtr := GetData(par); { in irgendwelchen MausDisk-Buffern }
      g := GrpToNetGrp[AnGruppe];
      if g > 255 then begin
        NetPar.NetGrpB := 255;
        NetPar.NetGrpW := g;
      end else
        NetPar.NetGrpB := g;
      NetPar.MinusId := ReplyId;
      if Distribution = DiNichts then begin
        if MsgMinus>0 then begin
          {--- hole Status der "Frage" }
          OldNum := Nummer;
          pb := GetParameterExact('A', MsgMinus);
          pbk := pb^; pb := @pbk; { Umkopieren, damit pParameterblock lokal
            und nicht in m7disk-Puffern }
          if pb^.Distribution = diNichts then
            if pb^.ImNetz or (pb^.Sendernummer < 0) then { old compatibility }
              pb^.Distribution := diNet;
          par := GetParameterExact('A', OldNum);
          { fr nchstes GetParameter }
        end else
          pb := nil;
        SetDistribution(par, pb, DataPtr, nil);
        if Distribution > DiNichts then
          PutParameter(par, tsnOk);
      end;
      NetPar.Distribution := Distribution;
    end;
  end;

  procedure KonvertiereNetMsg(var par: PParameterblock);
  {--- Mitteilung aus Maus-/FidoNet: NICHT konvertieren }
  begin
    with par^ do begin
      GetMemLen := DatenLaenge;
      GetHeap(DataNeu,GetMemLen);
      move(DataPtr^,DataNeu^,GetMemLen);
{      TypePtr(DataNeu,GetMemLen);}
      NetPar.Laenge := DatenLaenge;
      Konvertiert := true;
    end;
  end;

  procedure KonvertierePersMsg(var par: PParameterblock);
  begin
    with par^ do begin
      { ZielBox := NetPar.ZielBox; }
      LStatus := 'M'; { ins 'M'ausNet exportiert }
      LDatum := today;
      LZeit := GetTimeInt;
      PutParameter(par, tsnNeu);
      GetMemLen := DatenLaenge;
      GetHeap(DataNeu,GetMemLen);
      move(DataPtr^,DataNeu^,GetMemLen);
      NetPar.Laenge := DatenLaenge;
      Konvertiert := true;
    end;
  end;

  procedure MitteilungTo(pb: pParameterBlock; b: box);
  {--- verschicke LokalEingetragene/MausNet/FidoNet-Mitteilung an Box b}
  begin
    if not konvertiert then begin
      if pb^.Status='P' then
        KonvertierePersMsg(pb)
      else
        KonvertiereNetMsg(pb)
    end;
    AddMitteilung(b,NetPar,DataNeu);
  end;

  procedure ExitMitteilung;
  begin
    if konvertiert then begin
      FreeHeap(DataNeu,GetMemLen); { Speicher freigeben }
      konvertiert:=false;
    end;
  end;

{--------- eine Mitteilung aus lokaler Datei in alle Boxen verteilen ---------}

function MitteilungAllgEx(var par: PParameterblock): boolean;
var
  db: DirectBox;
  NetGrp: NetzGruppe;
begin
  MitteilungAllgEx := false;
  InitNetPar(par);
  with par^ do begin
    (*
    if (NetId.Box in ThisAndFremd) and (SenderNummer<>0) then begin
      2.60 Test: *)
    if (SenderNummer<>0) and (Sendernummer<>-2) then begin
            NetGrp := GrpToNetGrp[AnGruppe];
      if NetGrp<>NoGrp then begin
        {--- Gruppe existiert im Netz }
        Write(log,'A',MsgId(NetPar.Id));
        InitMitteilung(par);
        Write(log, {' K:',MsgId(NetPar.MinusId),}' ',NetPar.StichWort, ' -> ');
        if par^.Distribution > DiLokal then begin
          MsgStat('A', ThisBox, ThisBox, par^.Datenlaenge);
          GrpStat(NetGrp, par^.Datenlaenge);
          { Summe in Diagonale eintragen !}
          MitteilungAllgEx := true;
          for db := 1 to MaxDirectBox do begin
            {--- alle angeschlossenen Boxen durchgehen }
            if NotFremd[db] and (NetGrpInfo[NetGrp]^.ToBox[db]<>NichtImNetz) then
              MitteilungTo(par, DirectToBox[db]);
          end;
          if not (NetId.Box in ThisAndFremd) then
            write(log, '<Export:Sender:', Sendernummer, '>');
        end else
          write(log, '(lokal)');
        WritelnLog;
        ExitMitteilung;
      end;
    end;
  end;
end;

procedure MitteilungPersEx(var par: PParameterblock);
var
  b,ViaBox: Box;
  Von,An: AdrStr;
  Data: PDaten;
  GatewayDist: integer;
  direct: boolean;
begin
  with par^ do begin
    if (NetId.Box in ThisAndFremd) and (EmpfaengerNummer=NetzMitt) then begin
      write(log, 'P', MsgId(NetId),' ');
      InitNetPar(par);
      DataPtr := GetData(par); { in irgendwelchen MausDisk-Buffern }
      Data := DataPtr;

      GetAdrLines(Data, Von, An);
      b := FindZielBox(An, GatewayDist, direct);
      if direct then NetPar.NetGrpB := b; { ZielBox := b }
      ViaBox := GetViaBox(b);
      write(log, 'Von: ', Von, ' an: ', An, ' -> ');
      if par^.Datenlaenge > LangePersMsg then begin
        {--- PersMsg berschreitet gewisse Lnge }
        write(log,' [',par^.Datenlaenge,' Bytes] ');
      end;
      if ViaBox>0 then begin
        { write(log, BoxName(ViaBox)); }
        NetPar.MinusId := par^.ReplyId;
        MsgStat('P', ThisBox, ThisBox, par^.Datenlaenge);
        { Summe in Diagonale eintragen !}
        MitteilungTo(par, ViaBox);
        WritelnLog;
      end else begin
        writeln(log, 'keine Verbindung zu Adressat-Box!');
      end;
      ExitMitteilung;
    end;
  end;
end;

procedure StatusTo(var Stat: NetzStatus; b: Box);
var
  db: DirectBox;
begin
  db:=Boxen^[b].Direct;
  OpenStatusFile(db);
  with ExportFiles[db] do begin
    seek(StaFile, FileSize(StaFile));
    write(StaFile,Stat);
  end;
  CloseStatusFile(db);
end;

procedure MitteilungStatusEx(var par: PParameterblock);
var
  Stat: NetzStatus;
  ViaBox: Box;
begin
  if par^.Sendernummer=NetzMitt then begin
    with Stat do begin
      FillChar(Stat, sizeof(Stat), 0);
      Status := 'P';
      if par^.LStatus='N' then LStatus := 'A'{ngekommen}
      else LStatus := par^.LStatus;
      LDatum := par^.LDatum;
      LZeit := par^.LZeit;
      Id := par^.NetId;
      ZielBox := par^.NetId.Box;
      ViaBox := GetViaBox(ZielBox);
      if ViaBox>0 then begin
        write(log,'S',MsgId(Id),' = ',
                LStatus,' ',DatumSeit(LDatum),' ',ZeitSeit(LZeit));
        WritelnLog;
        StatusTo(Stat, ViaBox);
        PutParameter(par, tsnAlt); { als exportiert markieren }
      end;
    end;
  end;
end;

procedure ChangeLStatus(Stat: NetzStatus);
var
  pb: PParameterblock;
  ViaBox: Box;
begin
  with Stat do begin
    write(log,'S',MsgId(Id),' ',
          LStatus,' ',DatumSeit(LDatum),' ',ZeitSeit(LZeit),' -> ');
    if ZielBox in ThisAndFremd then begin
      {--- hier ndern: erst mal Msg suchen}
      pb := GetParameterExact('P', FindNetMsg('P', Id));
      if pb<>nil then begin
        write(log, '#', pb^.nummer);
        WritelnLog;
        pb^.LStatus := LStatus;
        pb^.LDatum := LDatum;
        pb^.LZeit := LZeit;
        PutParameter(pb, tsnNeu);
      end else begin
        writeln(log, 'nicht gefunden.');
      end;
    end else begin
      {--- weiterschicken }
      ViaBox := GetViaBox(ZielBox);
      if ViaBox>0 then StatusTo(Stat, ViaBox);
      write(log, BoxName(ZielBox),' via ', BoxName(ViaBox));
      WritelnLog;
    end;
  end;
end;

begin
  NetMsgNum := (GetDateInt mod 100)*100;
  LangePersMsg := GetConfigInteger('LangePersMsg', 5000);
  PMMassenFilter := longint(GetConfigWord('PMMassenFilter', 64)) * 1024;
  PMMassenHinweis := longint(GetConfigWord('PMMassenHinweis', 0)) * 1024;
  PMsum.First := true; PMsum.ZuLang := false; PMsum.GenMsg := false;
end.
