{ MNMITTHI.PAS - bergeordnete Msg-Routinen }

unit mnmitthi;

{$A-,B-,E-,N-,R+,S+,V-}

INTERFACE

uses
  crt,dos,m7utillo,m7config,
  m7raw,m7fileio,m7dec,m7time,m7disk,m7utilg,m7msg,
  mnDef,mnLog,mnUtil,mnMitt, m7exec
  {$ifdef OS2} ,use32 {$endif};

const
  Entpacken: boolean = true; { MAUSNET IMPORT setzt dies um }

procedure ExtrahiereEigeneMitteilungen(AbAllg, AbPers: word);

procedure VerteileEmpfangeneDaten(VonBox: Box);

procedure LookForOldImports;

procedure PMStatusCheck;


IMPLEMENTATION

{------------- lokale Mitteilungsdatei auf nderungen durchgehen -------------}

var
  NetGrpExport, ExportMax: word;
  PMVerlustMin, PMVerlustMax: word;
  MsgNetBufKB: word;

procedure ExtrahiereEigeneMitteilungen(AbAllg, AbPers: word);
type
  aParameterBlock = array[1..65536 div sizeof(TParameterblock)] of TParameterblock;
var
  ParAlt: file;
  ParAltBuf: ^aParameterBlock;
  ParAltBufSize, ParAltBufMax, ParAltBufNum: word;

  procedure InitParAltBuf;
  begin
    ParAltBufSize := MsgNetBufKB * 1024 div sizeof(TParameterblock);
    GetMem(ParAltBuf, ParAltBufSize*sizeof(TParameterblock));
    ParAltBufNum := 0;
    ParAltBufMax := 0;
  end;

  procedure ExitParAltBuf;
  begin
    FreeMem(ParAltBuf, ParAltBufSize*sizeof(TParameterblock));
  end;

  function AllgFilesOeffnen: boolean;
  var
    AltD, NeuD: longint;
  begin
    { Backup direkt verwalten }
    {$I-}
    assign(ParAlt, MittAllgPath + MittAllgName + '.NET');
    reset(ParAlt, sizeof(TParameterBlock));
    {$I+}
    if IOresult<>0 then begin
      { netzeigenes Backup gibt's noch nicht: also anlegen }
      writeln(log, MittAllgName + '.NET wird angelegt.');
      CloseParameter;
      IO(CopyFile(MittAllgPath + MittAllgName + '.PAR',
                  MittAllgPath + MittAllgName + '.NET'));
      assign(ParAlt,MittAllgPath + MittAllgName + '.NET');
      reset(ParAlt, sizeof(TParameterBlock));
    end;
    InitParAltBuf;
    writeln(log, MittAllgName + '.PAR wird mit ' + MittAllgName + '.NET verglichen.');
    { aktuelle Version ber m7Disk .. }
    ResetParameter('A');
    AltD := GetFileTime(ParAlt, 0);
    NeuD := GetFileTime(m7disk.MsgParFile, today);
    AllgFilesOeffnen := NeuD > AltD;
  end;

  function PersFilesOeffnen: boolean;
  var
    AltD, NeuD: longint;
  begin
    {$I-}
    assign(ParAlt, MittPersPath + MittPersName + '.NET');
    reset(ParAlt, sizeof(TParameterBlock));
    {$I+}
    if IOresult>0 then begin
      { netzeigenes Backup gibt's noch nicht: also anlegen }
      writeln(log, MittPersName + '.NET wird angelegt.');
      CloseParameter;
      IO(CopyFile(MittPersPath + MittPersName + '.PAR',
                  MittPersPath + MittPersName + '.NET'));
      assign(ParAlt, MittPersPath + MittPersName + '.NET');
      reset(ParAlt, sizeof(TParameterBlock));
    end;
    InitParAltBuf;
    writeln(log, MittPersName + '.PAR wird mit ' + MittPersName + '.NET verglichen.');
    ResetParameter('P');
    AltD := GetFileTime(ParAlt, 0);
    NeuD := GetFileTime(m7disk.MsgParFile, today);
    PersFilesOeffnen := NeuD > AltD;
  end;

  procedure AllgFilesSchliessen(changed: boolean);
  var
    dummy: byte;
  begin
    close(ParAlt);
    ExitParAltBuf;
    CloseParameter;
    { aktuelles Mitteilungs-Parameter-File als Backup fr morgen }
    if changed then begin
      writeln(log, 'COPY ', MittAllgName, '.PAR -> ', MittAllgName, '.NET');
      IO(CopyFile(MittAllgPath + MittAllgName + '.PAR',
                  MittAllgPath + MittAllgName + '.NET'));
    end;
    {--- Netz-Referenz auf aktuelles Datum bringen }
    assign(ParAlt, MittAllgPath + MittAllgName + '.NET');
    {$I-}
    reset(ParAlt, 1);
    BlockRead(ParAlt, dummy, 1);
    {$I+}
    if IOresult = 0 then begin
      reset(ParAlt, 1);
      BlockWrite(ParAlt, dummy, 1);
      close(ParAlt);
    end else
      SysopLog('Fehler: ' + MittAllgName + '.NET nicht da');
  end;

  procedure PersFilesSchliessen(changed: boolean);
  begin
    close(ParAlt);
    ExitParAltBuf;
    CloseParameter;
    { aktuelles Mitteilungs-Parameter-File als Backup fr morgen }
    if changed then begin
      writeln(log, 'COPY ', MittPersName, '.PAR -> ', MittPersName, '.NET');
      IO(CopyFile(MittPersPath + MittPersName + '.PAR',
                  MittPersPath + MittPersName + '.NET'));
    end;
  end;

  function LeseMitteilungAlt: PParameterBlock;
  begin
    Inc(ParAltBufNum);
    if (ParAltBufNum > ParAltBufMax) then begin
      if eof(ParAlt) then begin
        LeseMitteilungAlt := nil;
        exit;
      end;
      BlockRead(ParAlt, ParAltBuf^, ParAltBufSize, ParAltBufMax);
      ParAltBufNum := 1;
    end;
    LeseMitteilungAlt := @ParAltBuf^[ParAltBufNum];
  end;

  function LeseMitteilungNeu: PParameterBlock;
  begin
    LeseMitteilungNeu := GetParameter;
  end;

  procedure BufToMsg(var buf; FileName: string; len: word; Grp: Netzgruppe);
  var
    b: box;
    db: DirectBox;
    p: pDaten;
  begin
    p := pdaten(@buf);
    fillChar(NetPar,sizeof(NetPar),0);
    with NetPar do begin
      Laenge:=len;
      Status:='F';
      Id.Nummer:=GetDateInt; { jeder Tag: eigene Nummer }
      Id.Box:=ThisBox;
      Stichwort:=FileName;
      NetGrpB:=Grp;
      if Grp = SysopsNetGrp then begin
        for db:=1 to MaxDirectBox do begin
          {--- alle angeschlossenen Boxen durchgehen }
          b := DirectToBox[db];
          if NotFremd[db] and (not (b in NoExpTo)) then begin
            AddMitteilung(b,NetPar,p);
          end;
        end;
      end else
        {--- Kontroll-Msg fr Netzzentrale - nur nach oben }
        AddMitteilung(ServerBox, NetPar, p);
    end;
  end;

  procedure FileToMsg(FileName: PathStr);
  var
    Dir: DirStr;
    Name: NameStr;
    Ext: ExtStr;
    f: file;
    Laenge: word;
  begin
    FSplit(FileName,Dir,Name,Ext);
    {$I-}
    assign(f,FileName);
    reset(f,1);
    {$I+}
    if IOresult>0 then begin
      SysopLog('ExportFile ' + FileName + ' nicht gefunden.');
      exit;
    end;
    Laenge:=FileSize(f);
    if Laenge>DataBufMax then begin
      close(f);
      SysopLog('ExportFile ' + FileName + ' zu lang.');
      exit;
    end;
    GetMemLen:=Laenge;
    GetMem(DataNeu,GetMemLen);
    BlockRead(f,DataNeu^,GetMemLen);
    close(f);
    BufToMsg(DataNeu^, Name+Ext, Laenge, SysopsNetGrp);
    FreeMem(DataNeu,GetMemLen);
  end;

  procedure NetConfigExport;
  var
    f: file;
    LastNetTime,NetGrpTime: LongInt;
    ngf: file of GrpInfoRec;
    GrpInfo: GrpInfoRec;
    g: word;
    dt: DateTime;
    NetDate, NetTime: integer;
    b: Box;
    HeuteMod7: integer;

    procedure ExportIfNew(b: Box);
    var
      ConfigTime,ExportTime: LongInt;
      ConfName: PathStr;

      procedure ConvertCNF;
      var
        fe, fc: text;
        p, n, e: integer;
        z, g: string;
      begin
        assign(fc, ConfName+'.CNF '); reset(fc);
        assign(fe, ConfName+'.EXP '); rewrite(fe);
        repeat
          { ab ';' lschen, Gates maskieren }
          readln(fc, z);
          p := pos(';', z);
          if p > 0 then z[0] := chr(p-1);
          TrimRight(z);
          if UpStr(copyL(z, 2)) = 'G:' then begin
            Val(copyR(z, 3), n, e);
            if e <> 0 then begin
              g := copyR(z, e + 2);
              Trim(g);
              if GetConfigBoolean('MaskGate' + g, True) then
                z := '';
            end
          end;
          if z <> '' then writeln(fe, z);
        until eof(fc);
        close(fc);
        close(fe);
      end;

    var
      f: text;
      IoError: integer;
      GSet: tGruppenSet;
    begin { ExportIfNew }
      { neue Gruppenbestellung exportieren }
      write(log, 'Export BOX-GRP fr ', BoxName(b), ' -> ');
      GetBoxGrpRec(b, GSet);
      BufToMsg(GSet, BoxName(b) + '.GRP', sizeof(GSet), SysopsNetGrp);
      writeln(log);
      { Filename fr neues CNF/EXP }
      ConfName := MakeNameNeu(b);
      {$I-}
      assign(f,ConfName+'.CNF');
      reset(f);
      {$I+}
      IoError := IoResult;
      if IoError > 0 then begin
        SysopLog('Fehler #' + IntToStr(IoError) + ': ' + ConfName + '.CNF');
        exit; { HUCH: File nicht da ... }
      end;
      ConfigTime := GetFileTime(f, today);
      close(f);
      if ConfigTime > LastNetTime then begin
        {$I-}
        assign(f,ConfName+'.EXP');
        reset(f);
        {$I+}
        if IOresult=0 then begin
          ExportTime := GetFileTime(f, today);
          close(f);
        end else
          ExportTime:=0;
        if ExportTime < ConfigTime then begin
          writeln(log,'.EXP lter als .CNF, bzw. nicht da! .EXP wird angelegt.');
          ConvertCnf;
        end;
        write(log,'Net-Config ', ConfName, '.EXP wird als Msg exportiert -> ');
        FileToMsg(ConfName+'.EXP');
        writeln(log);
      end;
    end; { ExportIfNew }

  begin { NetConfigExport }
    {$I-}
    assign(f,MittAllgPath + MittAllgName + '.NET');
    reset(f);
    {$I+}
    if IOresult=0 then begin
      LastNetTime := GetFileTime(f, 0);
      close(f);
    end else
      LastNetTime:=0;

    for b := 1 to MaxBoxen do begin
      if b in ThisAndFremd then
        ExportIfNew(b);
    end;

    if (NetMode = Nachtnetz) and (ServerBox <> 0) then begin
      {--- auer in der Netzzentrale Timing-Info nach oben schicken }
      if TimLast.IchBin = ThisBox then begin
        writeln(log, 'Export ', TimingFile, ' ', DatumSeit(TimLast.Datum));
        BufToMsg(TimLast, TimingFile, sizeof(TimLast), 0);
      end;
    end;

    if NetGrpExport = ThisBox*42 - 17 then begin
      {--- Netz-Koordinator exportiert NET-GRP.DAT }
      assign(ngf, MausNetPath + NetGrpFile);
      reset(ngf);
      NetGrpTime := GetFileTime(ngf, today);
      UnPackTime(LastNetTime, dt);
      with dt do begin
        NetDate := TMJtoInt(day, month, year-1900);
        NetTime := hour * 60 + min;
      end;
      if NetGrpTime > LastNetTime then
        writeln(log,'NET-GRP.DAT gendert nach dem ',
                     DatumSeit(NetDate),', ',ZeitSeit(NetTime));
      g := 0;
      if NetMode = Nachtnetz then
        { im normalen MausNet in sieben Tagen alle Gruppen exportieren }
        HeuteMod7 := GetDateInt mod 7
      else
        HeuteMod7 := 255;
      repeat
        read(ngf, GrpInfo);
        with GrpInfo do begin
          if (Name <> '') then begin
            if ((g mod 7) = HeuteMod7)
            or (LastEdit > NetDate)
            or ((LastEdit = NetDate) and (LastEditTime > NetTime)) then begin
              write(log,'Export ',g:3,' ',Name,' -> ');
              BufToMsg(GrpInfo, 'NETGRP.'+ IntToStr(g), sizeof(GrpInfo), SysopsNetGrp);
              writeln(log);
            end;
          end;
        end;
        inc(g);
      until eof(ngf);
    end;
  end;

  procedure ExportMsgs(Allg: boolean; AbMsg: word);
  var
    pbAlt,pbNeu: PParameterBlock;
    AltZuEnde,NeuZuEnde: boolean;
    Geloescht,Neu,NeuGleichAlt,JetztAlle,Changed: boolean;
    MsgAnz: word;
  begin {ExportMsgs}
    {--- neue Msgs und bei Pers-Msgs auch Status-nderungen exportieren }
    { wenn AbMsg<>0, dann wird ab AbMsg@ThisBox alles exportiert }

    if Allg then Changed := AllgFilesOeffnen else Changed := PersFilesOeffnen;

    if Changed or (AbMsg > 0) then begin
      AltZuEnde:=false; NeuZuEnde:=false;
      JetztAlle:=false;
      MsgAnz := 0;
      repeat
        pbNeu := LeseMitteilungNeu;
        NeuZuEnde := pbNeu=nil;
        NeuGleichAlt := false;
        if (AbMsg>0) and (not neuzuende)
        and (pbNeu^.NetId.Box=ThisBox) and (pbNeu^.NetId.Nummer=AbMsg)
        and (pbNeu^.EDatum >= today - 7) then begin
          writeln(log, '>>> JetztAlle');
          JetztAlle := true;
        end;

        {--- alte Mitteilung durchsuchen, bis neue gefunden }
        while (not AltZuEnde) and (not NeuGleichAlt) do begin
          pbAlt := LeseMitteilungAlt;
          if pbAlt = nil then begin
            AltZuEnde := true;
          end else begin
            NeuGleichAlt := (not neuzuende) and
                            (pbAlt^.NetId.Box = pbNeu^.NetId.Box) and
                            (pbAlt^.NetId.Nummer = pbNeu^.NetId.Nummer);
          end;
        end;

        Neu := (JetztAlle or AltZuEnde) and ParOk(pbNeu);

        if Allg then begin
          if Neu then begin
            if (pbNeu^.Sendernummer < -2) or (pbNeu^.Sendernummer > 0) then begin
              if MitteilungAllgEx(pbNeu) then begin
                inc(MsgAnz);
                if MsgAnz > ExportMax then begin
                  NeuZuEnde := true; AltZuEnde := true;
                  SysopLog('Export abgebrochen: mehr als ' + IntToStr(ExportMax) + ' Msgs!');
                  SysopLog('  Bitte fortsetzen mit MAUSNET EXPORT?   ab AllgMsg: ' + IntToStr(pbNeu^.NetId.Nummer+1) + '.');
                end;
              end;
            end else begin
              if pbNeu^.NetId.Box in ThisAndFremd then
                write(log, '<SendNr:', pbNeu^.Sendernummer, ':', MsgId(pbNeu^.NetId), '>');
            end;
          end;
        end else { not Allg } begin
          if Neu then
            MitteilungPersEx(pbNeu);
          if Neu {-> 'A'ngekommen}
          or (NeuGleichAlt and (pbNeu^.LStatus <> pbAlt^.LStatus)) then
            MitteilungStatusEx(pbNeu)
        end;

      until AltZuEnde and NeuZuEnde;
    end else
      writeln(log, '  Keine Vernderung.');
    if Allg then AllgFilesSchliessen(changed) else PersFilesSchliessen(changed);
  end;

begin { ExtrahiereEigeneMitteilungen }
  ProfilerStart('Export');
  FromBox := ThisBox;
  NetConfigExport;
  writeln(log,'Export fr allgemeine Msgs');
  ExportMsgs(true, AbAllg);  { allgemeine Msgs }
  writeln(log,'Export fr persnliche Msgs');
  ExportMsgs(false, AbPers); { persnliche Msgs }
  CloseExportFiles;
  ProfilerEnde('Export');
end;

procedure PMStatusCheck;
var
  pb: PParameterBlock;
  Diff: integer;
  dz: pDaten;
  Von, An: string;
  B: Box;
  Gate: integer;
  direct: boolean;
  jetzt: integer;
begin
  Writeln(log);
  Writeln(log, 'Lesestatus-Check fr persnliche Mitteilungen');
  Writeln(log);
  ResetParameter('P');
  Jetzt := GetTimeInt;
  repeat
    pb := GetParameter;
    if ParOk(pb) then
      if pb^.Empfaengernummer = NetzMitt then
        with pb^ do begin
          if LStatus = 'M'{ausNet} then begin
            Diff := (integer(Jetzt) - LZeit) div 60 + (today - LDatum) * 24;
            if (Diff > PMVerlustMin) and (Diff < PMVerlustMax) then begin
              dz := GetData(pb);
              GetAdrLines(dz, Von, An);
              B := FindZielBox(An, Gate, direct);
              SysopLog('P' + MsgId(NetId) + ' -> ' + BoxName(B)
                + ' nicht angekommen(?) seit ' + IntToStr(Diff) + ' Stunden.');
            end;
          end;
        end;
  until pb = nil;
  CloseParameter;
end;

{======== IN: empfangene Mitteilungen verteilen (lokal/andere Boxen) =========}

procedure VerteileEmpfangeneDaten(VonBox: Box);
var
  NetPar: NetzMittParameter;
  ParFile: file of NetzMittParameter;
  DatFile: file;
  StaFile: file of NetzStatus;

  procedure NetzFilesEntpacken(VonBox: box);
  var
    D: DirStr;
    N: NameStr;
    E: ExtStr;
  begin
    ProfilerStart('Entpacken');
    { Name:=GenName(VonBox,ThisBox); }
    { Sch... Seiteneffekte: GotFileName wird in mnAnruf gesetzt }
    fsplit(GotFileName, D, N, E);
    cdd(NetIOPath);
    Exec('PKUNZIP -o ' + N + E + ' ' + N + '.*', true, false);
    cdd(MausNetPath);
    ProfilerEnde('Entpacken');
  end;

  function OpenImportFile(VonBox: box): boolean;
  var
    Name: string[64];
  begin
    Name:=GenName(VonBox,ThisBox);
    OpenImportFile := false;
    {$I-}
    { evtl. nichts empfangen ?!? }
    assign(ParFile,Name+'.par');
    reset(ParFile);
    {$I+}
    if IoResult>0 then begin
      SysopLog(Name + '.PAR nicht da.');
      exit;
    end;
    assign(DatFile,Name+'.dat');
    reset(DatFile,1);
    {$I-}
    { mu nicht existieren }
    assign(StaFile,Name+'.sta');
    reset(StaFile);
    {$I+}
    if IoResult>0 then begin
      rewrite(StaFile);
      close(StaFile);
      reset(StaFile);
    end;
    OpenImportFile := true;
  end;

  procedure DeleteImportFiles;
  var
    f: file;
    D: DirStr;
    N: NameStr;
    E: ExtStr;
    NewFileName: PathStr;
  begin
    close(ParFile); erase(ParFile);
    close(DatFile); erase(DatFile);
    close(StaFile); erase(StaFile);
    if Entpacken then begin
      { frher MNAC2AC-.ZIP -> MOAC2AC-.ZIP
        jetzt  AC2-AC--.ZIP -> AC2-$$$$.ZIP }
      FSplit(GotFileName, D, N, E);
      N := CopyL(N, 4) + '$$$$';
      NewFileName := D + N + E;
      {$I-}
      assign(f, NewFileName);
      erase(f);
      if IOresult > 0 then;
      assign(f, GotFileName);
      rename(f, NewFileName);
      if IOresult > 0 then
        SysopLog('Rename ' + GotFileName + ' ' + NewFileName + ' nicht mglich.');
      {$I+}
    end;
  end;

  function GetMitteilung(var NetPar: NetzMittParameter; var Data: PDaten): boolean;
  var
    ok: boolean;
    i: word;
  begin
    read(ParFile,NetPar);
    ok := true;
    {--- Plausibilittscheck }
    if (pos(NetPar.Status, 'AGPF') = 0) then begin
      ok := false;
      SysopLog('Mllparameter ' + NetPar.Status + ' ' + MsgId(NetPar.Id));
    end else begin
      with NetPar do begin
        {$I-}
        seek(DatFile,DatenOffset);
        ok := (IOresult = 0);
        if ok then begin
          if Laenge > DataBufMax then begin
            writeln(log, '<Lnge ', Laenge, ' gekappt>');
            Laenge := DataBufMax;
          end;
          blockread(DatFile, DataBuf, Laenge);
          ok := (IOresult = 0);
        end;
        {$I+}
        Data := PDaten(@DataBuf);
        if ok then begin
          if NetPar.Status <> 'F' then begin
            if pos(chr(DataBuf[0]), 'VKW '#13) = 0 then begin
              write(log, 'Mlldaten: ');
              for i := 0 to 60 do
                if DataBuf[i] >= $20 then
                  write(log, chr(DataBuf[i]))
                else
                  write(log, '<', DataBuf[i], '>');
              writeln(log);
              SysopProt('Mlldaten ' + NetPar.Status + ' ' + MsgId(NetPar.Id));
              ok := false;
            end;
          end;
        end else
          SysopLog('Lesefehler ' + NetPar.Status + ' ' + MsgId(NetPar.Id));
      end;
    end;
    GetMitteilung := ok;
  end;

var
  b: Box;
  db: DirectBox;
  DataPtr: PDaten;
  Verteilt: boolean;
  Stat: NetzStatus;
  g: word;
begin { VerteileEmpfangeneDaten }
  ProfilerStart('Verteilen');
  if Entpacken then NetzFilesEntpacken(VonBox);
  if (NetMode = Nachtnetz) and (Boxen^[VonBox].UeberMir) then
    tim.t[EPx] := GetSecondInt;
  today:=TageSeit(GetDate);
  {--- Allgemeine/persnliche Mitteilungen importieren/weiterverteilen }
  if not OpenImportFile(VonBox) then
    writeln(log,'Keine Mitteilungen empfangen.')
  else begin
    FromBox := VonBox;
    MassenUpdate := true; { lokale Msg-Base erst am Ende schlieen }
    while not eof(ParFile) do begin
     if GetMitteilung(NetPar,DataPtr) then begin
      Verteilt := false;
      if NetPar.Status <> 'F' then
        MsgStat(NetPar.Status, FromBox, FromBox, NetPar.Laenge);
        { Summe in Diagonale eintragen !}
      if NetPar.Status='P' then begin
        {--- persnliche Msg: erstmal fr lokal halten ... }
        ProfilerStart('Pers-Msg');
        AddMitteilung(ThisBox, NetPar, DataPtr);
        ProfilerEnde ('Pers-Msg');
      end else begin
        {--- allgemeine Msg: weiter verteilen }
        ProfilerStart('Allg-Msg');
        SchonDa := false;
        {--- erst lokal eintragen (und auf Dupe berprfen) }
        Write(log,'A',MsgId(NetPar.Id), {' K:',MsgId(NetPar.MinusId),}
                  ' ',NetPar.StichWort, ' -> ');
        g := GetNetGrp(NetPar);
        if (NetPar.Status = 'F') and (g = 0) then begin
          {--- Kontroll-Msg an Zentrale: hier eintragen }
          AddMitteilung(ThisBox, NetPar, DataPtr);
          if (ServerBox <> 0) and (ServerBox <> FromBox) then
            {--- und hochschicken, wenn nicht schon da/von da! }
            AddMitteilung(ServerBox, NetPar, DataPtr);
          WritelnLog;
        end else begin
          if (NetGrpInfo[g]^.ToGrp <> NoGrp)
            or (NetPar.Status = 'F') then begin
              {--- lokal eintragen) }
              ProfilerStart('Msg lokal');
              AddMitteilung(ThisBox, NetPar, DataPtr);
              Verteilt := true;
              ProfilerEnde ('Msg lokal');
            end;
          if not SchonDa then begin
            {--- wenn kein Dupe, an alle angeschlossenen Boxen verteilen }
            ProfilerStart('Msg weiter');
            if NetPar.Status = 'A' then
              GrpStat(g, NetPar.Laenge);
            for db:=1 to MaxDirectBox do begin
              b := DirectToBox[db];
              if (b<>VonBox) and (b<>NetPar.Id.Box)
              and (not Boxen^[b].FremdBox) then begin   { nicht Absender-Box    }
                if (NetGrpInfo[g]^.ToBox[db] <> NichtImNetz)
                                                        {   und bekommt Gruppe  }
                or ((NetPar.Status='F') and not (b in NoExpTo)) then begin
                                                        {     oder FileToMsg    }
                                                        { ==> weiterverteilen   }
                  AddMitteilung(b, NetPar, DataPtr);
                  Verteilt := true;
                end;
              end;
            end;
            if not Verteilt then
              { Gruppe nicht konfiguriert ? Mll ? }
              Writeln(log, 'NICHT eingetragen (Netzgruppe #', g,')')
            else
              WritelnLog;
            ProfilerEnde ('Msg weiter');
          end;
        end;
        ProfilerEnde ('Allg-Msg');
      end;
     end;
    end;
    AddMitteilungExit;

    {--- Status-nderungen bearbeiten }
    ProfilerStart('Status');
    while not eof(StaFile) do begin
      read(StaFile, Stat);
      if Stat.Status='P' then
        ChangeLStatus(Stat)
      else
        writeln(log,'Status-nderung ',Stat.Status,'?');
    end;
    ProfilerEnde ('Status');
    DeleteImportFiles;
    MassenUpdate := false;
    CloseParameter; { jetzt Msg-Base schlieen }
  end;

  CloseExportFiles; { Export-Files schliessen }
  ProfilerEnde('Verteilen');
end;

procedure LookForOldImports;
var
  FileName: PathStr;
  B: Box;

  procedure FindOldImport;
  var
    DoImport: boolean;
    SR: SearchRec;
    D, Dx: DirStr;
    N: NameStr;
    E: ExtStr;
    f: file;
  begin
    FSplit(FileName, D, N, E);
    FindFirst(FileName + '.*', AnyFile-Directory, SR);
    while DosError = 0 do begin
     FSplit(SR.Name, Dx, N, E);
     if pos(E, '.PAR.ZIP.ARC') > 0 then begin
      if SR.time > 0 then begin
        {--- komplettes File vorhanden }
        Entpacken := (E <> '.PAR');
        writeln(log);
        if NetMode <> NurImport then begin
          writeln(Log, 'Altes ' + SR.Name + ' gefunden. Importieren?');
          writeln(log, 'Wenn Import nicht gewnscht, bitte innerhalb von 5 Sekunden <ESC> tippen');
          while KeyPressed do if ReadKey <> esc then;
          SetTimeOut(5);
          repeat
          until TimeOut or KeyPressed;
          DoImport := not KeyPressed or (ReadKey <> esc);
        end else
          DoImport := true;
        if DoImport then begin
          GotFileName := D + N + E;
          SysopLog('Altes ' + SR.Name + ' gefunden. Wird importiert.');
          VerteileEmpfangeneDaten(B);
        end; (* else if Entpacken then begin
          {$I-}
          assign(f, SR.Name);
          erase(f);
          if IoResult > 0 then;
          {$I+}
        end; *)
        Entpacken := true;
      end else
        SysopLog('Altes inkomplettes ' + SR.Name + ' gefunden.');
     end;
     FindNext(SR);
    end;
  end;

begin { LookForOldImports }
  for B := 1 to MaxBoxen do begin
    if B in AnUnsDran then begin
      FileName := GenName(B, ThisBox);
      FindOldImport;
    end;
  end;
end;

var
  ExitSave: pointer;

{$F+}
procedure ExitMittHi;
begin
  {--- im Falle eines Absturz: }
  ExitProc := ExitSave;
  CloseParameter;
end;

begin
  ExitSave := ExitProc;
  ExitProc := @ExitMittHi;
  NetGrpExport := GetConfigInteger('NetGrpExport', 0);
  PMVerlustMin := GetConfigWord('PMVerlustMin', 72);
  PMVerlustMax := GetConfigWord('PMVerlustMax', 120);
  ExportMax := GetConfigWord('ExportMax', MaxWord);
  MsgNetBufKB := max(1, min(GetConfigWord('MsgNetBufKB', 16), 63));
end.

{ Ende von mnMittHi }
